#!/bin/sh
# Compare actual numbers from du, assuming block size matches mine.

if test "$VERBOSE" = yes; then
  set -x
  du --version
fi

# DU_BLOCK_SIZE could cause problems
. $srcdir/../envvar-check

pwd=`pwd`
t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
trap '(exit $?); exit $?' 1 2 13 15

framework_failure=0
mkdir -p $tmp || framework_failure=1
cd $tmp || framework_failure=1
mkdir -p a/b || framework_failure=1
printf 'make-sure-the-file-is-non-empty\n' > a/b/c || framework_failure=1

if test $framework_failure = 1; then
  echo "$0: failure in testing framework" 1>&2
  (exit 1); exit 1
fi

if test "`stat --format=%bx%B a`" != 8x512; then
  echo "$0: different block count/size, so skipping this test" 1>&2
  (exit 77); exit 77
fi

fail=0

du -a a > out || fail=1
echo === >> out
du -aS a >> out || fail=1
echo === >> out
du -s a >> out || fail=1
cat <<\EOF > exp
4	a/b/c
8	a/b
12	a
===
4	a/b/c
4	a/b
4	a
===
12	a
EOF

cmp out exp || fail=1
test $fail = 1 && diff out exp 2> /dev/null

(exit $fail); exit $fail
